#ifndef __BINARY_DECOMPOSITION_H__
#define __BINARY_DECOMPOSITION_H__

#include <vector>
#include <cstdlib>

#include "utils/graph.h"

using std::vector;

class Decomposition {
public:
  vector<vector<double> > A;
  vector<vector<double> > &B;
  int f;
  Graph *g;
  double r;
  bool equiv;

  Decomposition(Graph *_g, int _f, double _r, bool _equiv);
  void initRandomize(double min, double max);
  void initEpsilon(double eps);
  void initToDegrees();
  void load(const char folder[256]);
  void save(const char folder[256]);

  double score(int i, int j);
  bool predicted(int i, int j, double r);
};

class BinaryDecomposition {
public:
  virtual double getR() = 0;
  virtual Decomposition* calc(size_t iter, double absstop, double relstop) = 0;
  virtual ~BinaryDecomposition() {};

  double calcF(Decomposition*);
  virtual void calcGradient(Decomposition *oth, int f1, double gradA[], double gradB[]) = 0;
};

#endif
